//
//  ResourceManager.swift
//  TVScratch
//
//  Created by Chris Adamson on 4/6/18.
//  Copyright © 2018 Subsequently & Furthermore, Inc. All rights reserved.
//

import Foundation

// NOTE: a more elaborate app might want to provide a download progress UI too

class ResourceManager {
  
  static var shared: ResourceManager = ResourceManager()

  func loadTag(named name: String,
               completionHandler: @escaping (Error?) ->Void) {
    let tags: Set<String> = [name]
    let request = NSBundleResourceRequest(tags: tags)
    request.conditionallyBeginAccessingResources { success in
      if success {
        print ("already had \(name)")
        completionHandler(nil)
      } else {
        print ("beginning access for \(name)")
        request.beginAccessingResources() { errorOrNil in
          completionHandler(errorOrNil)
        }
      }
    }
  }
}
